/* minefield.c generated by valac 0.40.0, the Vala compiler
 * generated from minefield.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define TYPE_FLAG_TYPE (flag_type_get_type ())

#define TYPE_LOCATION (location_get_type ())
#define LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LOCATION, Location))
#define LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LOCATION, LocationClass))
#define IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LOCATION))
#define IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LOCATION))
#define LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LOCATION, LocationClass))

typedef struct _Location Location;
typedef struct _LocationClass LocationClass;
typedef struct _LocationPrivate LocationPrivate;
enum  {
	LOCATION_0_PROPERTY,
	LOCATION_NUM_PROPERTIES
};
static GParamSpec* location_properties[LOCATION_NUM_PROPERTIES];

#define TYPE_NEIGHBOUR (neighbour_get_type ())
typedef struct _Neighbour Neighbour;

#define TYPE_MINEFIELD (minefield_get_type ())
#define MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MINEFIELD, Minefield))
#define MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MINEFIELD, MinefieldClass))
#define IS_MINEFIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MINEFIELD))
#define IS_MINEFIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MINEFIELD))
#define MINEFIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MINEFIELD, MinefieldClass))

typedef struct _Minefield Minefield;
typedef struct _MinefieldClass MinefieldClass;
typedef struct _MinefieldPrivate MinefieldPrivate;
enum  {
	MINEFIELD_0_PROPERTY,
	MINEFIELD_N_CLEARED_PROPERTY,
	MINEFIELD_IS_COMPLETE_PROPERTY,
	MINEFIELD_N_FLAGS_PROPERTY,
	MINEFIELD_USE_AUTOFLAG_PROPERTY,
	MINEFIELD_ELAPSED_PROPERTY,
	MINEFIELD_PAUSED_PROPERTY,
	MINEFIELD_NUM_PROPERTIES
};
static GParamSpec* minefield_properties[MINEFIELD_NUM_PROPERTIES];
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	MINEFIELD_CLOCK_STARTED_SIGNAL,
	MINEFIELD_PAUSED_CHANGED_SIGNAL,
	MINEFIELD_TICK_SIGNAL,
	MINEFIELD_REDRAW_SECTOR_SIGNAL,
	MINEFIELD_MARKS_CHANGED_SIGNAL,
	MINEFIELD_EXPLODE_SIGNAL,
	MINEFIELD_CLEARED_SIGNAL,
	MINEFIELD_NUM_SIGNALS
};
static guint minefield_signals[MINEFIELD_NUM_SIGNALS] = {0};

typedef enum  {
	FLAG_TYPE_NONE,
	FLAG_TYPE_FLAG,
	FLAG_TYPE_MAYBE
} FlagType;

struct _Location {
	GObject parent_instance;
	LocationPrivate * priv;
	gboolean has_mine;
	gboolean cleared;
	FlagType flag;
	gint adjacent_mines;
};

struct _LocationClass {
	GObjectClass parent_class;
};

struct _Neighbour {
	gint x;
	gint y;
};

struct _Minefield {
	GObject parent_instance;
	MinefieldPrivate * priv;
	guint width;
	guint height;
	guint n_mines;
	Location** locations;
	gint locations_length1;
	gint locations_length2;
	gboolean exploded;
	gboolean placed_mines;
	gboolean _use_autoflag;
};

struct _MinefieldClass {
	GObjectClass parent_class;
};

struct _MinefieldPrivate {
	guint _n_cleared;
	guint _n_flags;
	gdouble clock_elapsed;
	GTimer* clock;
	guint clock_timeout;
	gboolean _paused;
};


static gpointer location_parent_class = NULL;
static gpointer minefield_parent_class = NULL;

GType flag_type_get_type (void) G_GNUC_CONST;
GType location_get_type (void) G_GNUC_CONST;
Location* location_new (void);
Location* location_construct (GType object_type);
static void location_finalize (GObject * obj);
GType neighbour_get_type (void) G_GNUC_CONST;
Neighbour* neighbour_dup (const Neighbour* self);
void neighbour_free (Neighbour* self);
GType minefield_get_type (void) G_GNUC_CONST;
#define MINEFIELD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MINEFIELD, MinefieldPrivate))
Minefield* minefield_new (guint width,
                          guint height,
                          guint n_mines);
Minefield* minefield_construct (GType object_type,
                                guint width,
                                guint height,
                                guint n_mines);
gboolean minefield_is_clock_started (Minefield* self);
gdouble minefield_get_elapsed (Minefield* self);
gboolean minefield_has_mine (Minefield* self,
                             guint x,
                             guint y);
gboolean minefield_is_cleared (Minefield* self,
                               guint x,
                               guint y);
gboolean minefield_is_location (Minefield* self,
                                gint x,
                                gint y);
void minefield_multi_release (Minefield* self,
                              guint x,
                              guint y);
FlagType minefield_get_flag (Minefield* self,
                             guint x,
                             guint y);
guint minefield_get_n_adjacent_mines (Minefield* self,
                                      guint x,
                                      guint y);
gboolean minefield_get_use_autoflag (Minefield* self);
void minefield_clear_mine (Minefield* self,
                           guint x,
                           guint y);
void minefield_set_flag (Minefield* self,
                         guint x,
                         guint y,
                         FlagType flag);
static void minefield_place_mines (Minefield* self,
                            guint x,
                            guint y);
static void minefield_start_clock (Minefield* self);
static void minefield_clear_mines_recursive (Minefield* self,
                                      guint x,
                                      guint y);
static void minefield_stop_clock (Minefield* self);
gboolean minefield_get_is_complete (Minefield* self);
guint minefield_get_n_cleared (Minefield* self);
void minefield_set_n_cleared (Minefield* self,
                              guint value);
guint minefield_get_n_flags (Minefield* self);
void minefield_set_n_flags (Minefield* self,
                            guint value);
gboolean minefield_has_flag_warning (Minefield* self,
                                     guint x,
                                     guint y);
static void minefield_start_timer (Minefield* self);
static gboolean minefield_timeout_cb (Minefield* self);
static gboolean _minefield_timeout_cb_gsource_func (gpointer self);
static void minefield_continue_clock (Minefield* self);
void minefield_set_use_autoflag (Minefield* self,
                                 gboolean value);
gboolean minefield_get_paused (Minefield* self);
void minefield_set_paused (Minefield* self,
                           gboolean value);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void minefield_finalize (GObject * obj);
static void _vala_minefield_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_minefield_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

const Neighbour neighbour_map[8] = {{-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}};

GType
flag_type_get_type (void)
{
	static volatile gsize flag_type_type_id__volatile = 0;
	if (g_once_init_enter (&flag_type_type_id__volatile)) {
		static const GEnumValue values[] = {{FLAG_TYPE_NONE, "FLAG_TYPE_NONE", "none"}, {FLAG_TYPE_FLAG, "FLAG_TYPE_FLAG", "flag"}, {FLAG_TYPE_MAYBE, "FLAG_TYPE_MAYBE", "maybe"}, {0, NULL, NULL}};
		GType flag_type_type_id;
		flag_type_type_id = g_enum_register_static ("FlagType", values);
		g_once_init_leave (&flag_type_type_id__volatile, flag_type_type_id);
	}
	return flag_type_type_id__volatile;
}


Location*
location_construct (GType object_type)
{
	Location * self = NULL;
	self = (Location*) g_object_new (object_type, NULL);
	return self;
}


Location*
location_new (void)
{
	return location_construct (TYPE_LOCATION);
}


static void
location_class_init (LocationClass * klass)
{
	location_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = location_finalize;
}


static void
location_instance_init (Location * self)
{
	self->has_mine = FALSE;
	self->cleared = FALSE;
	self->flag = FLAG_TYPE_NONE;
	self->adjacent_mines = 0;
}


static void
location_finalize (GObject * obj)
{
	Location * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LOCATION, Location);
	G_OBJECT_CLASS (location_parent_class)->finalize (obj);
}


GType
location_get_type (void)
{
	static volatile gsize location_type_id__volatile = 0;
	if (g_once_init_enter (&location_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Location), 0, (GInstanceInitFunc) location_instance_init, NULL };
		GType location_type_id;
		location_type_id = g_type_register_static (G_TYPE_OBJECT, "Location", &g_define_type_info, 0);
		g_once_init_leave (&location_type_id__volatile, location_type_id);
	}
	return location_type_id__volatile;
}


Neighbour*
neighbour_dup (const Neighbour* self)
{
	Neighbour* dup;
	dup = g_new0 (Neighbour, 1);
	memcpy (dup, self, sizeof (Neighbour));
	return dup;
}


void
neighbour_free (Neighbour* self)
{
	g_free (self);
}


GType
neighbour_get_type (void)
{
	static volatile gsize neighbour_type_id__volatile = 0;
	if (g_once_init_enter (&neighbour_type_id__volatile)) {
		GType neighbour_type_id;
		neighbour_type_id = g_boxed_type_register_static ("Neighbour", (GBoxedCopyFunc) neighbour_dup, (GBoxedFreeFunc) neighbour_free);
		g_once_init_leave (&neighbour_type_id__volatile, neighbour_type_id);
	}
	return neighbour_type_id__volatile;
}


Minefield*
minefield_construct (GType object_type,
                     guint width,
                     guint height,
                     guint n_mines)
{
	Minefield * self = NULL;
	Location** _tmp0_;
	self = (Minefield*) g_object_new (object_type, NULL);
	_tmp0_ = g_new0 (Location*, (width * height) + 1);
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
	self->locations = _tmp0_;
	self->locations_length1 = width;
	self->locations_length2 = height;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = x;
				if (!(((guint) _tmp3_) < width)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gint _tmp6_;
							Location** _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
							gint _tmp9_;
							Location* _tmp10_;
							Location* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = y;
								y = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = y;
							if (!(((guint) _tmp6_) < height)) {
								break;
							}
							_tmp7_ = self->locations;
							_tmp7__length1 = self->locations_length1;
							_tmp7__length2 = self->locations_length2;
							_tmp8_ = x;
							_tmp9_ = y;
							_tmp10_ = location_new ();
							_g_object_unref0 (_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_]);
							_tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_] = _tmp10_;
							_tmp11_ = _tmp7_[(_tmp8_ * _tmp7__length2) + _tmp9_];
						}
					}
				}
			}
		}
	}
	self->width = width;
	self->height = height;
	self->n_mines = n_mines;
	return self;
}


Minefield*
minefield_new (guint width,
               guint height,
               guint n_mines)
{
	return minefield_construct (TYPE_MINEFIELD, width, height, n_mines);
}


gboolean
minefield_is_clock_started (Minefield* self)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = minefield_get_elapsed (self);
	_tmp1_ = _tmp0_;
	result = _tmp1_ > ((gdouble) 0);
	return result;
}


gboolean
minefield_has_mine (Minefield* self,
                    guint x,
                    guint y)
{
	gboolean result = FALSE;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->locations;
	_tmp0__length1 = self->locations_length1;
	_tmp0__length2 = self->locations_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _tmp1_->has_mine;
	result = _tmp2_;
	return result;
}


gboolean
minefield_is_cleared (Minefield* self,
                      guint x,
                      guint y)
{
	gboolean result = FALSE;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->locations;
	_tmp0__length1 = self->locations_length1;
	_tmp0__length2 = self->locations_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _tmp1_->cleared;
	result = _tmp2_;
	return result;
}


gboolean
minefield_is_location (Minefield* self,
                       gint x,
                       gint y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (x >= 0) {
		_tmp2_ = y >= 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		guint _tmp3_;
		_tmp3_ = self->width;
		_tmp1_ = ((guint) x) < _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint _tmp4_;
		_tmp4_ = self->height;
		_tmp0_ = ((guint) y) < _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void
minefield_multi_release (Minefield* self,
                         guint x,
                         guint y)
{
	gboolean _tmp0_ = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint n_unknown = 0U;
	gboolean do_clear = FALSE;
	guint _tmp13_;
	guint _tmp14_;
	g_return_if_fail (self != NULL);
	if (!minefield_is_cleared (self, x, y)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = minefield_get_flag (self, x, y) == FLAG_TYPE_FLAG;
	}
	if (_tmp0_) {
		return;
	}
	n_mines = minefield_get_n_adjacent_mines (self, x, y);
	n_flags = (guint) 0;
	n_unknown = (guint) 0;
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
		neighbour_collection = neighbour_map;
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
			Neighbour neighbour = {0};
			neighbour = neighbour_collection[neighbour_it];
			{
				gint nx = 0;
				Neighbour _tmp1_;
				gint _tmp2_;
				gint ny = 0;
				Neighbour _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp10_;
				gint _tmp11_;
				_tmp1_ = neighbour;
				_tmp2_ = _tmp1_.x;
				nx = ((gint) x) + _tmp2_;
				_tmp3_ = neighbour;
				_tmp4_ = _tmp3_.y;
				ny = ((gint) y) + _tmp4_;
				_tmp5_ = nx;
				_tmp6_ = ny;
				if (!minefield_is_location (self, _tmp5_, _tmp6_)) {
					continue;
				}
				_tmp7_ = nx;
				_tmp8_ = ny;
				if (minefield_get_flag (self, (guint) _tmp7_, (guint) _tmp8_) == FLAG_TYPE_FLAG) {
					guint _tmp9_;
					_tmp9_ = n_flags;
					n_flags = _tmp9_ + 1;
				}
				_tmp10_ = nx;
				_tmp11_ = ny;
				if (!minefield_is_cleared (self, (guint) _tmp10_, (guint) _tmp11_)) {
					guint _tmp12_;
					_tmp12_ = n_unknown;
					n_unknown = _tmp12_ + 1;
				}
			}
		}
	}
	do_clear = FALSE;
	_tmp13_ = n_mines;
	_tmp14_ = n_flags;
	if (_tmp13_ == _tmp14_) {
		do_clear = TRUE;
	} else {
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_;
		gboolean _tmp17_;
		_tmp16_ = minefield_get_use_autoflag (self);
		_tmp17_ = _tmp16_;
		if (_tmp17_) {
			guint _tmp18_;
			guint _tmp19_;
			_tmp18_ = n_unknown;
			_tmp19_ = n_mines;
			_tmp15_ = _tmp18_ == _tmp19_;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			do_clear = FALSE;
		} else {
			return;
		}
	}
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
		neighbour_collection = neighbour_map;
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
			Neighbour neighbour = {0};
			neighbour = neighbour_collection[neighbour_it];
			{
				gint nx = 0;
				Neighbour _tmp20_;
				gint _tmp21_;
				gint ny = 0;
				Neighbour _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gboolean _tmp26_ = FALSE;
				gboolean _tmp27_;
				_tmp20_ = neighbour;
				_tmp21_ = _tmp20_.x;
				nx = ((gint) x) + _tmp21_;
				_tmp22_ = neighbour;
				_tmp23_ = _tmp22_.y;
				ny = ((gint) y) + _tmp23_;
				_tmp24_ = nx;
				_tmp25_ = ny;
				if (!minefield_is_location (self, _tmp24_, _tmp25_)) {
					continue;
				}
				_tmp27_ = do_clear;
				if (_tmp27_) {
					gint _tmp28_;
					gint _tmp29_;
					_tmp28_ = nx;
					_tmp29_ = ny;
					_tmp26_ = minefield_get_flag (self, (guint) _tmp28_, (guint) _tmp29_) != FLAG_TYPE_FLAG;
				} else {
					_tmp26_ = FALSE;
				}
				if (_tmp26_) {
					gint _tmp30_;
					gint _tmp31_;
					_tmp30_ = nx;
					_tmp31_ = ny;
					minefield_clear_mine (self, (guint) _tmp30_, (guint) _tmp31_);
				} else {
					gint _tmp32_;
					gint _tmp33_;
					_tmp32_ = nx;
					_tmp33_ = ny;
					minefield_set_flag (self, (guint) _tmp32_, (guint) _tmp33_, FLAG_TYPE_FLAG);
				}
			}
		}
	}
}


void
minefield_clear_mine (Minefield* self,
                      guint x,
                      guint y)
{
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
	Location** _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	Location* _tmp6_;
	gboolean _tmp7_;
	Location** _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	Location* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->placed_mines;
	if (!_tmp0_) {
		minefield_place_mines (self, x, y);
		self->placed_mines = TRUE;
	}
	_tmp2_ = self->exploded;
	if (!_tmp2_) {
		GTimer* _tmp3_;
		_tmp3_ = self->priv->clock;
		_tmp1_ = _tmp3_ == NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		minefield_start_clock (self);
	}
	_tmp5_ = self->locations;
	_tmp5__length1 = self->locations_length1;
	_tmp5__length2 = self->locations_length2;
	_tmp6_ = _tmp5_[(x * _tmp5__length2) + y];
	_tmp7_ = _tmp6_->cleared;
	if (_tmp7_) {
		_tmp4_ = TRUE;
	} else {
		Location** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		Location* _tmp9_;
		FlagType _tmp10_;
		_tmp8_ = self->locations;
		_tmp8__length1 = self->locations_length1;
		_tmp8__length2 = self->locations_length2;
		_tmp9_ = _tmp8_[(x * _tmp8__length2) + y];
		_tmp10_ = _tmp9_->flag;
		_tmp4_ = _tmp10_ == FLAG_TYPE_FLAG;
	}
	if (_tmp4_) {
		return;
	}
	minefield_clear_mines_recursive (self, x, y);
	_tmp11_ = self->locations;
	_tmp11__length1 = self->locations_length1;
	_tmp11__length2 = self->locations_length2;
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
	_tmp13_ = _tmp12_->has_mine;
	if (_tmp13_) {
		gboolean _tmp14_;
		_tmp14_ = self->exploded;
		if (!_tmp14_) {
			self->exploded = TRUE;
			minefield_stop_clock (self);
			g_signal_emit (self, minefield_signals[MINEFIELD_EXPLODE_SIGNAL], 0);
		}
		return;
	}
	_tmp15_ = minefield_get_is_complete (self);
	_tmp16_ = _tmp15_;
	if (_tmp16_) {
		minefield_stop_clock (self);
		{
			gint tx = 0;
			tx = 0;
			{
				gboolean _tmp17_ = FALSE;
				_tmp17_ = TRUE;
				while (TRUE) {
					gint _tmp19_;
					guint _tmp20_;
					if (!_tmp17_) {
						gint _tmp18_;
						_tmp18_ = tx;
						tx = _tmp18_ + 1;
					}
					_tmp17_ = FALSE;
					_tmp19_ = tx;
					_tmp20_ = self->width;
					if (!(((guint) _tmp19_) < _tmp20_)) {
						break;
					}
					{
						gint ty = 0;
						ty = 0;
						{
							gboolean _tmp21_ = FALSE;
							_tmp21_ = TRUE;
							while (TRUE) {
								gint _tmp23_;
								guint _tmp24_;
								gint _tmp25_;
								gint _tmp26_;
								if (!_tmp21_) {
									gint _tmp22_;
									_tmp22_ = ty;
									ty = _tmp22_ + 1;
								}
								_tmp21_ = FALSE;
								_tmp23_ = ty;
								_tmp24_ = self->height;
								if (!(((guint) _tmp23_) < _tmp24_)) {
									break;
								}
								_tmp25_ = tx;
								_tmp26_ = ty;
								if (minefield_has_mine (self, (guint) _tmp25_, (guint) _tmp26_)) {
									gint _tmp27_;
									gint _tmp28_;
									_tmp27_ = tx;
									_tmp28_ = ty;
									minefield_set_flag (self, (guint) _tmp27_, (guint) _tmp28_, FLAG_TYPE_FLAG);
								}
							}
						}
					}
				}
			}
		}
		g_signal_emit (self, minefield_signals[MINEFIELD_CLEARED_SIGNAL], 0);
	}
}


static void
minefield_clear_mines_recursive (Minefield* self,
                                 guint x,
                                 guint y)
{
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gboolean _tmp2_;
	Location** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	Location* _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	Location** _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	Location* _tmp8_;
	FlagType _tmp9_;
	Location** _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	Location* _tmp13_;
	gboolean _tmp14_ = FALSE;
	Location** _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	Location* _tmp16_;
	gboolean _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->locations;
	_tmp0__length1 = self->locations_length1;
	_tmp0__length2 = self->locations_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _tmp1_->cleared;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = self->locations;
	_tmp3__length1 = self->locations_length1;
	_tmp3__length2 = self->locations_length2;
	_tmp4_ = _tmp3_[(x * _tmp3__length2) + y];
	_tmp4_->cleared = TRUE;
	_tmp5_ = minefield_get_n_cleared (self);
	_tmp6_ = _tmp5_;
	minefield_set_n_cleared (self, _tmp6_ + 1);
	_tmp7_ = self->locations;
	_tmp7__length1 = self->locations_length1;
	_tmp7__length2 = self->locations_length2;
	_tmp8_ = _tmp7_[(x * _tmp7__length2) + y];
	_tmp9_ = _tmp8_->flag;
	if (_tmp9_ == FLAG_TYPE_FLAG) {
		guint _tmp10_;
		guint _tmp11_;
		_tmp10_ = minefield_get_n_flags (self);
		_tmp11_ = _tmp10_;
		minefield_set_n_flags (self, _tmp11_ - 1);
	}
	_tmp12_ = self->locations;
	_tmp12__length1 = self->locations_length1;
	_tmp12__length2 = self->locations_length2;
	_tmp13_ = _tmp12_[(x * _tmp12__length2) + y];
	_tmp13_->flag = FLAG_TYPE_NONE;
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
	_tmp15_ = self->locations;
	_tmp15__length1 = self->locations_length1;
	_tmp15__length2 = self->locations_length2;
	_tmp16_ = _tmp15_[(x * _tmp15__length2) + y];
	_tmp17_ = _tmp16_->has_mine;
	if (!_tmp17_) {
		_tmp14_ = minefield_get_n_adjacent_mines (self, x, y) == ((guint) 0);
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		{
			Neighbour* neighbour_collection = NULL;
			gint neighbour_collection_length1 = 0;
			gint _neighbour_collection_size_ = 0;
			gint neighbour_it = 0;
			neighbour_collection = neighbour_map;
			neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
			for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
				Neighbour neighbour = {0};
				neighbour = neighbour_collection[neighbour_it];
				{
					gint nx = 0;
					Neighbour _tmp18_;
					gint _tmp19_;
					gint ny = 0;
					Neighbour _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _tmp23_;
					_tmp18_ = neighbour;
					_tmp19_ = _tmp18_.x;
					nx = ((gint) x) + _tmp19_;
					_tmp20_ = neighbour;
					_tmp21_ = _tmp20_.y;
					ny = ((gint) y) + _tmp21_;
					_tmp22_ = nx;
					_tmp23_ = ny;
					if (minefield_is_location (self, _tmp22_, _tmp23_)) {
						gint _tmp24_;
						gint _tmp25_;
						_tmp24_ = nx;
						_tmp25_ = ny;
						minefield_clear_mines_recursive (self, (guint) _tmp24_, (guint) _tmp25_);
					}
				}
			}
		}
	}
}


void
minefield_set_flag (Minefield* self,
                    guint x,
                    guint y,
                    FlagType flag)
{
	gboolean _tmp0_ = FALSE;
	Location** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	Location* _tmp2_;
	gboolean _tmp3_;
	Location** _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	Location* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->locations;
	_tmp1__length1 = self->locations_length1;
	_tmp1__length2 = self->locations_length2;
	_tmp2_ = _tmp1_[(x * _tmp1__length2) + y];
	_tmp3_ = _tmp2_->cleared;
	if (_tmp3_) {
		_tmp0_ = TRUE;
	} else {
		Location** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		Location* _tmp5_;
		FlagType _tmp6_;
		_tmp4_ = self->locations;
		_tmp4__length1 = self->locations_length1;
		_tmp4__length2 = self->locations_length2;
		_tmp5_ = _tmp4_[(x * _tmp4__length2) + y];
		_tmp6_ = _tmp5_->flag;
		_tmp0_ = _tmp6_ == flag;
	}
	if (_tmp0_) {
		return;
	}
	if (flag == FLAG_TYPE_FLAG) {
		guint _tmp7_;
		guint _tmp8_;
		_tmp7_ = minefield_get_n_flags (self);
		_tmp8_ = _tmp7_;
		minefield_set_n_flags (self, _tmp8_ + 1);
	} else {
		Location** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Location* _tmp10_;
		FlagType _tmp11_;
		_tmp9_ = self->locations;
		_tmp9__length1 = self->locations_length1;
		_tmp9__length2 = self->locations_length2;
		_tmp10_ = _tmp9_[(x * _tmp9__length2) + y];
		_tmp11_ = _tmp10_->flag;
		if (_tmp11_ == FLAG_TYPE_FLAG) {
			guint _tmp12_;
			guint _tmp13_;
			_tmp12_ = minefield_get_n_flags (self);
			_tmp13_ = _tmp12_;
			minefield_set_n_flags (self, _tmp13_ - 1);
		}
	}
	_tmp14_ = self->locations;
	_tmp14__length1 = self->locations_length1;
	_tmp14__length2 = self->locations_length2;
	_tmp15_ = _tmp14_[(x * _tmp14__length2) + y];
	_tmp15_->flag = flag;
	g_signal_emit (self, minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL], 0, x, y);
	g_signal_emit (self, minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL], 0);
}


FlagType
minefield_get_flag (Minefield* self,
                    guint x,
                    guint y)
{
	FlagType result = 0;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	FlagType _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->locations;
	_tmp0__length1 = self->locations_length1;
	_tmp0__length2 = self->locations_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _tmp1_->flag;
	result = _tmp2_;
	return result;
}


guint
minefield_get_n_adjacent_mines (Minefield* self,
                                guint x,
                                guint y)
{
	guint result = 0U;
	Location** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Location* _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->locations;
	_tmp0__length1 = self->locations_length1;
	_tmp0__length2 = self->locations_length2;
	_tmp1_ = _tmp0_[(x * _tmp0__length2) + y];
	_tmp2_ = _tmp1_->adjacent_mines;
	result = (guint) _tmp2_;
	return result;
}


gboolean
minefield_has_flag_warning (Minefield* self,
                            guint x,
                            guint y)
{
	gboolean result = FALSE;
	guint n_mines = 0U;
	guint n_flags = 0U;
	guint _tmp12_;
	guint _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (!minefield_is_cleared (self, x, y)) {
		result = FALSE;
		return result;
	}
	n_mines = (guint) 0;
	n_flags = (guint) 0;
	{
		Neighbour* neighbour_collection = NULL;
		gint neighbour_collection_length1 = 0;
		gint _neighbour_collection_size_ = 0;
		gint neighbour_it = 0;
		neighbour_collection = neighbour_map;
		neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
		for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
			Neighbour neighbour = {0};
			neighbour = neighbour_collection[neighbour_it];
			{
				gint nx = 0;
				Neighbour _tmp0_;
				gint _tmp1_;
				gint ny = 0;
				Neighbour _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				gint _tmp9_;
				gint _tmp10_;
				_tmp0_ = neighbour;
				_tmp1_ = _tmp0_.x;
				nx = ((gint) x) + _tmp1_;
				_tmp2_ = neighbour;
				_tmp3_ = _tmp2_.y;
				ny = ((gint) y) + _tmp3_;
				_tmp4_ = nx;
				_tmp5_ = ny;
				if (!minefield_is_location (self, _tmp4_, _tmp5_)) {
					continue;
				}
				_tmp6_ = nx;
				_tmp7_ = ny;
				if (minefield_has_mine (self, (guint) _tmp6_, (guint) _tmp7_)) {
					guint _tmp8_;
					_tmp8_ = n_mines;
					n_mines = _tmp8_ + 1;
				}
				_tmp9_ = nx;
				_tmp10_ = ny;
				if (minefield_get_flag (self, (guint) _tmp9_, (guint) _tmp10_) == FLAG_TYPE_FLAG) {
					guint _tmp11_;
					_tmp11_ = n_flags;
					n_flags = _tmp11_ + 1;
				}
			}
		}
	}
	_tmp12_ = n_flags;
	_tmp13_ = n_mines;
	result = _tmp12_ > _tmp13_;
	return result;
}


static void
minefield_place_mines (Minefield* self,
                       guint x,
                       guint y)
{
	g_return_if_fail (self != NULL);
	{
		gint n = 0;
		n = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp1_;
				guint _tmp2_;
				gint32 rx = 0;
				guint _tmp3_;
				gint32 ry = 0;
				guint _tmp4_;
				gboolean _tmp5_ = FALSE;
				gint32 _tmp6_;
				Location** _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint32 _tmp9_;
				gint32 _tmp10_;
				Location* _tmp11_;
				gboolean _tmp12_;
				if (!_tmp0_) {
				}
				_tmp0_ = FALSE;
				_tmp1_ = n;
				_tmp2_ = self->n_mines;
				if (!(((guint) _tmp1_) < _tmp2_)) {
					break;
				}
				_tmp3_ = self->width;
				rx = g_random_int_range ((gint32) 0, (gint32) _tmp3_);
				_tmp4_ = self->height;
				ry = g_random_int_range ((gint32) 0, (gint32) _tmp4_);
				_tmp6_ = rx;
				if (((guint) _tmp6_) == x) {
					gint32 _tmp7_;
					_tmp7_ = ry;
					_tmp5_ = ((guint) _tmp7_) == y;
				} else {
					_tmp5_ = FALSE;
				}
				if (_tmp5_) {
					continue;
				}
				_tmp8_ = self->locations;
				_tmp8__length1 = self->locations_length1;
				_tmp8__length2 = self->locations_length2;
				_tmp9_ = rx;
				_tmp10_ = ry;
				_tmp11_ = _tmp8_[(_tmp9_ * _tmp8__length2) + _tmp10_];
				_tmp12_ = _tmp11_->has_mine;
				if (!_tmp12_) {
					gboolean adj_found = FALSE;
					gboolean _tmp20_;
					adj_found = FALSE;
					{
						Neighbour* neighbour_collection = NULL;
						gint neighbour_collection_length1 = 0;
						gint _neighbour_collection_size_ = 0;
						gint neighbour_it = 0;
						neighbour_collection = neighbour_map;
						neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
						for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
							Neighbour neighbour = {0};
							neighbour = neighbour_collection[neighbour_it];
							{
								gboolean _tmp13_ = FALSE;
								gint32 _tmp14_;
								Neighbour _tmp15_;
								gint _tmp16_;
								_tmp14_ = rx;
								_tmp15_ = neighbour;
								_tmp16_ = _tmp15_.x;
								if (((guint) _tmp14_) == (x + _tmp16_)) {
									gint32 _tmp17_;
									Neighbour _tmp18_;
									gint _tmp19_;
									_tmp17_ = ry;
									_tmp18_ = neighbour;
									_tmp19_ = _tmp18_.y;
									_tmp13_ = ((guint) _tmp17_) == (y + _tmp19_);
								} else {
									_tmp13_ = FALSE;
								}
								if (_tmp13_) {
									adj_found = TRUE;
									break;
								}
							}
						}
					}
					_tmp20_ = adj_found;
					if (!_tmp20_) {
						Location** _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
						gint32 _tmp22_;
						gint32 _tmp23_;
						Location* _tmp24_;
						gint _tmp25_;
						_tmp21_ = self->locations;
						_tmp21__length1 = self->locations_length1;
						_tmp21__length2 = self->locations_length2;
						_tmp22_ = rx;
						_tmp23_ = ry;
						_tmp24_ = _tmp21_[(_tmp22_ * _tmp21__length2) + _tmp23_];
						_tmp24_->has_mine = TRUE;
						_tmp25_ = n;
						n = _tmp25_ + 1;
						{
							Neighbour* neighbour_collection = NULL;
							gint neighbour_collection_length1 = 0;
							gint _neighbour_collection_size_ = 0;
							gint neighbour_it = 0;
							neighbour_collection = neighbour_map;
							neighbour_collection_length1 = G_N_ELEMENTS (neighbour_map);
							for (neighbour_it = 0; neighbour_it < G_N_ELEMENTS (neighbour_map); neighbour_it = neighbour_it + 1) {
								Neighbour neighbour = {0};
								neighbour = neighbour_collection[neighbour_it];
								{
									gint32 nx = 0;
									gint32 _tmp26_;
									Neighbour _tmp27_;
									gint _tmp28_;
									gint32 ny = 0;
									gint32 _tmp29_;
									Neighbour _tmp30_;
									gint _tmp31_;
									gint32 _tmp32_;
									gint32 _tmp33_;
									_tmp26_ = rx;
									_tmp27_ = neighbour;
									_tmp28_ = _tmp27_.x;
									nx = _tmp26_ + _tmp28_;
									_tmp29_ = ry;
									_tmp30_ = neighbour;
									_tmp31_ = _tmp30_.y;
									ny = _tmp29_ + _tmp31_;
									_tmp32_ = nx;
									_tmp33_ = ny;
									if (minefield_is_location (self, (gint) _tmp32_, (gint) _tmp33_)) {
										Location** _tmp34_;
										gint _tmp34__length1;
										gint _tmp34__length2;
										gint32 _tmp35_;
										gint32 _tmp36_;
										Location* _tmp37_;
										gint _tmp38_;
										_tmp34_ = self->locations;
										_tmp34__length1 = self->locations_length1;
										_tmp34__length2 = self->locations_length2;
										_tmp35_ = nx;
										_tmp36_ = ny;
										_tmp37_ = _tmp34_[(_tmp35_ * _tmp34__length2) + _tmp36_];
										_tmp38_ = _tmp37_->adjacent_mines;
										_tmp37_->adjacent_mines = _tmp38_ + 1;
									}
								}
							}
						}
					}
				}
			}
		}
	}
}


static gboolean
_minefield_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = minefield_timeout_cb ((Minefield*) self);
	return result;
}


static void
minefield_start_timer (Minefield* self)
{
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock_timeout;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->clock_timeout;
		g_source_remove (_tmp1_);
	}
	self->priv->clock_timeout = (guint) 0;
	self->priv->clock_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _minefield_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
}


static void
minefield_start_clock (Minefield* self)
{
	GTimer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		GTimer* _tmp1_;
		_tmp1_ = g_timer_new ();
		_g_timer_destroy0 (self->priv->clock);
		self->priv->clock = _tmp1_;
	}
	g_signal_emit (self, minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL], 0);
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
	minefield_start_timer (self);
}


static void
minefield_stop_clock (Minefield* self)
{
	GTimer* _tmp0_;
	gdouble _tmp1_;
	GTimer* _tmp2_;
	gdouble _tmp3_;
	guint _tmp4_;
	GTimer* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp1_ = self->priv->clock_elapsed;
	_tmp2_ = self->priv->clock;
	_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
	self->priv->clock_elapsed = _tmp1_ + _tmp3_;
	_tmp4_ = self->priv->clock_timeout;
	if (_tmp4_ != ((guint) 0)) {
		guint _tmp5_;
		_tmp5_ = self->priv->clock_timeout;
		g_source_remove (_tmp5_);
	}
	self->priv->clock_timeout = (guint) 0;
	_tmp6_ = self->priv->clock;
	g_timer_stop (_tmp6_);
	_g_timer_destroy0 (self->priv->clock);
	self->priv->clock = NULL;
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
}


static void
minefield_continue_clock (Minefield* self)
{
	GTimer* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->clock;
	if (_tmp0_ == NULL) {
		GTimer* _tmp1_;
		_tmp1_ = g_timer_new ();
		_g_timer_destroy0 (self->priv->clock);
		self->priv->clock = _tmp1_;
	} else {
		GTimer* _tmp2_;
		_tmp2_ = self->priv->clock;
		g_timer_continue (_tmp2_);
	}
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
	minefield_start_timer (self);
}


static gboolean
minefield_timeout_cb (Minefield* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_signal_emit (self, minefield_signals[MINEFIELD_TICK_SIGNAL], 0);
	result = TRUE;
	return result;
}


guint
minefield_get_n_cleared (Minefield* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_n_cleared;
	result = _tmp0_;
	return result;
}


void
minefield_set_n_cleared (Minefield* self,
                         guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_n_cleared = value;
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_N_CLEARED_PROPERTY]);
}


gboolean
minefield_get_is_complete (Minefield* self)
{
	gboolean result;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = minefield_get_n_cleared (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->width;
	_tmp3_ = self->height;
	_tmp4_ = self->n_mines;
	result = _tmp1_ == ((_tmp2_ * _tmp3_) - _tmp4_);
	return result;
}


guint
minefield_get_n_flags (Minefield* self)
{
	guint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_n_flags;
	result = _tmp0_;
	return result;
}


void
minefield_set_n_flags (Minefield* self,
                       guint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_n_flags = value;
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_N_FLAGS_PROPERTY]);
}


gboolean
minefield_get_use_autoflag (Minefield* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->_use_autoflag;
	result = _tmp0_;
	return result;
}


void
minefield_set_use_autoflag (Minefield* self,
                            gboolean value)
{
	g_return_if_fail (self != NULL);
	self->_use_autoflag = value;
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY]);
}


gdouble
minefield_get_elapsed (Minefield* self)
{
	gdouble result;
	gdouble _tmp0_ = 0.0;
	GTimer* _tmp1_;
	gdouble _tmp4_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp1_ = self->priv->clock;
	if (_tmp1_ == NULL) {
		_tmp0_ = 0.0;
	} else {
		GTimer* _tmp2_;
		gdouble _tmp3_;
		_tmp2_ = self->priv->clock;
		_tmp3_ = g_timer_elapsed (_tmp2_, NULL);
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = self->priv->clock_elapsed;
	result = _tmp4_ + _tmp0_;
	return result;
}


gboolean
minefield_get_paused (Minefield* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_paused;
	result = _tmp0_;
	return result;
}


void
minefield_set_paused (Minefield* self,
                      gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp1_ = minefield_get_is_complete (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp3_;
		_tmp3_ = self->exploded;
		_tmp0_ = _tmp3_;
	}
	if (_tmp0_) {
		return;
	}
	if (value) {
		gboolean _tmp5_;
		_tmp5_ = self->priv->_paused;
		_tmp4_ = !_tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		minefield_stop_clock (self);
	} else {
		gboolean _tmp6_ = FALSE;
		if (!value) {
			gboolean _tmp7_;
			_tmp7_ = self->priv->_paused;
			_tmp6_ = _tmp7_;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			minefield_continue_clock (self);
		}
	}
	self->priv->_paused = value;
	g_signal_emit (self, minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, minefield_properties[MINEFIELD_PAUSED_PROPERTY]);
}


static void
g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
}


static void
minefield_class_init (MinefieldClass * klass)
{
	minefield_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MinefieldPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_minefield_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_minefield_set_property;
	G_OBJECT_CLASS (klass)->finalize = minefield_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_CLEARED_PROPERTY, minefield_properties[MINEFIELD_N_CLEARED_PROPERTY] = g_param_spec_uint ("n-cleared", "n-cleared", "n-cleared", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_IS_COMPLETE_PROPERTY, minefield_properties[MINEFIELD_IS_COMPLETE_PROPERTY] = g_param_spec_boolean ("is-complete", "is-complete", "is-complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_N_FLAGS_PROPERTY, minefield_properties[MINEFIELD_N_FLAGS_PROPERTY] = g_param_spec_uint ("n-flags", "n-flags", "n-flags", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_USE_AUTOFLAG_PROPERTY, minefield_properties[MINEFIELD_USE_AUTOFLAG_PROPERTY] = g_param_spec_boolean ("use-autoflag", "use-autoflag", "use-autoflag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_ELAPSED_PROPERTY, minefield_properties[MINEFIELD_ELAPSED_PROPERTY] = g_param_spec_double ("elapsed", "elapsed", "elapsed", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), MINEFIELD_PAUSED_PROPERTY, minefield_properties[MINEFIELD_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	minefield_signals[MINEFIELD_CLOCK_STARTED_SIGNAL] = g_signal_new ("clock-started", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	minefield_signals[MINEFIELD_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	minefield_signals[MINEFIELD_TICK_SIGNAL] = g_signal_new ("tick", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	minefield_signals[MINEFIELD_REDRAW_SECTOR_SIGNAL] = g_signal_new ("redraw-sector", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
	minefield_signals[MINEFIELD_MARKS_CHANGED_SIGNAL] = g_signal_new ("marks-changed", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	minefield_signals[MINEFIELD_EXPLODE_SIGNAL] = g_signal_new ("explode", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	minefield_signals[MINEFIELD_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_MINEFIELD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
minefield_instance_init (Minefield * self)
{
	self->priv = MINEFIELD_GET_PRIVATE (self);
	self->width = (guint) 0;
	self->height = (guint) 0;
	self->n_mines = (guint) 0;
	self->exploded = FALSE;
	self->placed_mines = FALSE;
	self->priv->_n_cleared = (guint) 0;
	self->priv->_n_flags = (guint) 0;
	self->priv->_paused = FALSE;
}


static void
minefield_finalize (GObject * obj)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MINEFIELD, Minefield);
	self->locations = (_vala_array_free (self->locations, self->locations_length1 * self->locations_length2, (GDestroyNotify) g_object_unref), NULL);
	_g_timer_destroy0 (self->priv->clock);
	G_OBJECT_CLASS (minefield_parent_class)->finalize (obj);
}


GType
minefield_get_type (void)
{
	static volatile gsize minefield_type_id__volatile = 0;
	if (g_once_init_enter (&minefield_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MinefieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) minefield_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Minefield), 0, (GInstanceInitFunc) minefield_instance_init, NULL };
		GType minefield_type_id;
		minefield_type_id = g_type_register_static (G_TYPE_OBJECT, "Minefield", &g_define_type_info, 0);
		g_once_init_leave (&minefield_type_id__volatile, minefield_type_id);
	}
	return minefield_type_id__volatile;
}


static void
_vala_minefield_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
	switch (property_id) {
		case MINEFIELD_N_CLEARED_PROPERTY:
		g_value_set_uint (value, minefield_get_n_cleared (self));
		break;
		case MINEFIELD_IS_COMPLETE_PROPERTY:
		g_value_set_boolean (value, minefield_get_is_complete (self));
		break;
		case MINEFIELD_N_FLAGS_PROPERTY:
		g_value_set_uint (value, minefield_get_n_flags (self));
		break;
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
		g_value_set_boolean (value, minefield_get_use_autoflag (self));
		break;
		case MINEFIELD_ELAPSED_PROPERTY:
		g_value_set_double (value, minefield_get_elapsed (self));
		break;
		case MINEFIELD_PAUSED_PROPERTY:
		g_value_set_boolean (value, minefield_get_paused (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_minefield_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	Minefield * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MINEFIELD, Minefield);
	switch (property_id) {
		case MINEFIELD_N_CLEARED_PROPERTY:
		minefield_set_n_cleared (self, g_value_get_uint (value));
		break;
		case MINEFIELD_N_FLAGS_PROPERTY:
		minefield_set_n_flags (self, g_value_get_uint (value));
		break;
		case MINEFIELD_USE_AUTOFLAG_PROPERTY:
		minefield_set_use_autoflag (self, g_value_get_boolean (value));
		break;
		case MINEFIELD_PAUSED_PROPERTY:
		minefield_set_paused (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



